unit csEnginefuncs;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csEnginefuncs.pas
  Description: Client enginefuncs hooks

  Be sure to read the Readme.txt for more information
}

interface

//====================================================================
uses
  SysUtils,
  Windows,
  csVars,
  uEngFuncs;
//====================================================================


//====================================================================
var ocsb_pfnSprLoad: function(const szPicName: Pchar):HSPRITE;cdecl;
var ocsb_pfnSPR_Set: procedure(hPic: HSPRITE; r,g,b: Integer);cdecl;
var ocsb_pfnFillRGBA: procedure (x, y, width, height, r, g, b, a: Integer);cdecl;
var ocsb_pfnGetScreenInfo: function(pscrinfo: SCREENINFO_s):Integer;cdecl;
var ocsb_pfnRegisterVariable: function(szName, szValue: PChar; flags: Integer):cvar_s;cdecl;
var ocsb_pfnGetCvarFloat: function(szName: PChar):Single;cdecl;
var ocsb_pfnAddCommand: function(cmd_name: PChar; pfunction: Pointer):Integer;cdecl;
var ocsb_pfnClientCmd: function(szCmdString: PChar):Integer;cdecl;
var ocsb_pfnGetPlayerInfo: procedure(ent_num: Integer; pinfo: hud_player_info_s);cdecl;
var ocsb_pfnPlaySoundByName: procedure(szSound:PChar; volume: Single);cdecl;
var ocsb_pfnAngleVectors: procedure(vecAngles: PSingle; _forward: Pointer; right: Pointer; up: Pointer);cdecl;
var ocsb_pfnConsolePrint: procedure (_string: PChar);cdecl;
var ocsb_GetViewAngles: procedure(pVector: vec3_s);cdecl;
var ocsb_SetViewAngles: procedure (pVector: vec3_s);cdecl;
var ocsb_GetEntityByIndex: function(idx: LongInt):cl_entity_s;cdecl;
var ocsb_PM_TraceLine: function(start: PSingle; _end: PSingle; flags: LongInt; usehull: LongInt; ignore_pe: LongInt):pmtrace_s;cdecl;
var ocsb_PlayerInfo_ValueForKey: function(playerNum: LongInt; key: PChar):PChar;cdecl;
//====================================================================


//====================================================================
procedure csb_HookClientEngine();
//====================================================================

implementation

//====================================================================
function csb_pfnSprLoad(const szPicName: Pchar):HSPRITE;cdecl;
begin

  result := ocsb_pfnSprLoad(szPicName);
end;
//====================================================================


//====================================================================
procedure csb_pfnSPR_Set(hPic: HSPRITE; r,g,b: Integer);cdecl;
begin

  ocsb_pfnSPR_Set(hPic, r, g, b);
end;
//====================================================================


//====================================================================
procedure csb_pfnFillRGBA(x, y, width, height, r, g, b, a: Integer);cdecl;
begin

  ocsb_pfnFillRGBA(x, y, width, height, r, g, b, a);
end;
//====================================================================


//====================================================================
function csb_pfnGetScreenInfo(pscrinfo: SCREENINFO_s):Integer;cdecl;
begin

  result := ocsb_pfnGetScreenInfo(pscrinfo);
end;
//====================================================================


//====================================================================
function csb_pfnRegisterVariable(szName, szValue: PChar; flags: Integer):cvar_s;cdecl;
begin

  result := ocsb_pfnRegisterVariable(szName, szValue, flags);
end;
//====================================================================


//====================================================================
function csb_pfnGetCvarFloat(szName: PChar):Single;cdecl;
begin

  result := ocsb_pfnGetCvarFloat(szName);
end;
//====================================================================


//====================================================================
function csb_pfnAddCommand(cmd_name: PChar; pfunction: Pointer):Integer;cdecl;
begin

  result := ocsb_pfnAddCommand(cmd_name, pfunction);
end;
//====================================================================


//====================================================================
function csb_pfnClientCmd(szCmdString: PChar):Integer;cdecl;
begin

  result := ocsb_pfnClientCmd(szCmdString);
end;
//====================================================================


//====================================================================
procedure csb_pfnGetPlayerInfo(ent_num: Integer; pinfo: hud_player_info_s);cdecl;
begin

  ocsb_pfnGetPlayerInfo(ent_num, pinfo);
end;
//====================================================================


//====================================================================
procedure csb_pfnPlaySoundByName(szSound:PChar; volume: Single);cdecl;
begin

  ocsb_pfnPlaySoundByName(szSound, volume);
end;
//====================================================================


//====================================================================
procedure csb_pfnAngleVectors(vecAngles: PSingle; _forward: Pointer; right: Pointer; up: Pointer);cdecl;
begin

  ocsb_pfnAngleVectors(vecAngles, _forward, right, up);
end;
//====================================================================


//====================================================================
procedure csb_pfnConsolePrint(_string: PChar);cdecl;
begin

  ocsb_pfnConsolePrint(_string);
end;
//====================================================================


//====================================================================
procedure csb_GetViewAngles(pVector: vec3_s);cdecl;
begin

  ocsb_GetViewAngles(pVector);
end;
//====================================================================


//====================================================================
procedure csb_SetViewAngles(pVector: vec3_s);cdecl;
begin

  ocsb_SetViewAngles(pVector);
end;
//====================================================================


//====================================================================
function csb_GetEntityByIndex(idx: LongInt):cl_entity_s;cdecl;
begin

  result := ocsb_GetEntityByIndex(idx);
end;
//====================================================================


//====================================================================
function csb_PM_TraceLine(start: PSingle; _end: PSingle; flags: LongInt; usehull: LongInt; ignore_pe: LongInt):pmtrace_s;cdecl;
begin

  result := ocsb_PM_TraceLine(start, _end, flags, usehull, ignore_pe);
end;
//====================================================================


//====================================================================
function csb_PlayerInfo_ValueForKey(playerNum: LongInt; key: PChar):PChar;cdecl;
begin

  result := ocsb_PlayerInfo_ValueForKey(playerNum, key);
end;
//====================================================================


//====================================================================
procedure csb_HookClientEngine;
begin
  origEngFuncs := VirtualAlloc(nil, sizeof(cl_enginefuncs_t), MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  CopyMemory(origEngFuncs, Pointer(pEngFuncs), sizeof(cl_enginefuncs_t));

  ocsb_pfnSprLoad := @origEngfuncs.pfnSprLoad;
  cl_enginefuncs_s(pEngFuncs).pfnSprLoad := @csb_pfnSprLoad;

  ocsb_pfnSPR_Set := @origEngfuncs.pfnSPR_Set;
  cl_enginefuncs_s(pEngFuncs).pfnSPR_Set := @csb_pfnSPR_Set;

  ocsb_pfnFillRGBA := @origEngfuncs.pfnFillRGBA;
  cl_enginefuncs_s(pEngFuncs).pfnFillRGBA := @csb_pfnFillRGBA;

  ocsb_pfnGetScreenInfo := @origEngfuncs.pfnGetScreenInfo;
  cl_enginefuncs_s(pEngFuncs).pfnGetScreenInfo := @csb_pfnGetScreenInfo;

  ocsb_pfnRegisterVariable := @origEngfuncs.pfnRegisterVariable;
  cl_enginefuncs_s(pEngFuncs).pfnRegisterVariable := @csb_pfnRegisterVariable;

  ocsb_pfnGetCvarFloat := @origEngfuncs.pfnGetCvarFloat;
  cl_enginefuncs_s(pEngFuncs).pfnGetCvarFloat := @csb_pfnGetCvarFloat;

  ocsb_pfnAddCommand := @origEngfuncs.pfnAddCommand;
  cl_enginefuncs_s(pEngFuncs).pfnAddCommand := @csb_pfnAddCommand;

  ocsb_pfnClientCmd := @origEngfuncs.pfnClientCmd;
  cl_enginefuncs_s(pEngFuncs).pfnClientCmd := @csb_pfnClientCmd;

  ocsb_pfnGetPlayerInfo := @origEngfuncs.pfnGetPlayerInfo;
  cl_enginefuncs_s(pEngFuncs).pfnGetPlayerInfo := @csb_pfnGetPlayerInfo;

  ocsb_pfnPlaySoundByName := @origEngfuncs.pfnPlaySoundByName;
  cl_enginefuncs_s(pEngFuncs).pfnPlaySoundByName := @csb_pfnPlaySoundByName;

  ocsb_pfnAngleVectors := @origEngfuncs.pfnAngleVectors;
  cl_enginefuncs_s(pEngFuncs).pfnAngleVectors := @csb_pfnAngleVectors;

  ocsb_pfnConsolePrint := @origEngfuncs.pfnConsolePrint;
  cl_enginefuncs_s(pEngFuncs).pfnConsolePrint := @csb_pfnConsolePrint;

  ocsb_GetViewAngles := @origEngfuncs.GetViewAngles;
  cl_enginefuncs_s(pEngFuncs).GetViewAngles := @csb_GetViewAngles;

  ocsb_SetViewAngles := @origEngfuncs.SetViewAngles;
  cl_enginefuncs_s(pEngFuncs).SetViewAngles := @csb_SetViewAngles;

  ocsb_GetEntityByIndex := @origEngfuncs.GetEntityByIndex;
  cl_enginefuncs_s(pEngFuncs).GetEntityByIndex := @csb_GetEntityByIndex;

  ocsb_PM_TraceLine := @origEngfuncs.PM_TraceLine;
  cl_enginefuncs_s(pEngFuncs).PM_TraceLine := @csb_PM_TraceLine;

  ocsb_PlayerInfo_ValueForKey := @origEngfuncs.PlayerInfo_ValueForKey;
  cl_enginefuncs_s(pEngFuncs).PlayerInfo_ValueForKey := @csb_PlayerInfo_ValueForKey;
end;
//====================================================================

end.