unit csExportTable;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csExportTable.pas
  Description: ExportTable hooks

  Be sure to read the Readme.txt for more information
}

interface

//====================================================================
uses
  SysUtils,
  Windows,
  csDetourHook,
  csVars,
  csSound,
  csUtilities,
  uEngFuncs;
//====================================================================


//====================================================================
var ocsb_HUD_Init: function(): Longint; cdecl;
var ocsb_HUD_Redraw: function(flTime: Single; iIntermission: Longint): Longint; cdecl;
var ocsb_HUD_PlayerMove: procedure(pPMove: PlayerMove_s; bH: Longint); cdecl;
var ocsb_CL_CreateMove: procedure(frameTime: Single; UserCmd: usercmd_s; active: Longint); cdecl;
var ocsb_V_CalcRefDef: procedure(pParams: ref_params_s); cdecl;
var ocsb_HUD_AddEntity: function(itype: Integer; ent: cl_entity_s; modelname: PChar):LongInt;cdecl;
var ocsb_HUD_PostRunCmd: procedure(from: Pointer; zTo: Pointer; UserCmd: usercmd_s; runfuncs: Integer; zTime: Single; random_seed: Word); cdecl;
var ocsb_HUD_Key_Event: function (eventCode: Integer; keynumb: Integer; pszCurrentBinding: PChar):Integer;cdecl;

var bClientOnce: Boolean = true;
//====================================================================


//====================================================================
procedure csb_HookET;
//====================================================================

implementation

//====================================================================
procedure WallhackProc;
begin
  Inc(gCvar.iWallhack, 1);

  if gCvar.iWallhack > 1 then gCvar.iWallhack := 0;
  if gCvar.iWallhack < 0 then gCvar.iWallhack := 1;
end;
//====================================================================


//====================================================================
procedure TeamglowProc;
begin
  Inc(gCvar.iTeamglow, 1);

  if gCvar.iTeamglow > 1 then gCvar.iTeamglow := 0;
  if gCvar.iTeamglow < 0 then gCvar.iTeamglow := 1;
end;
//====================================================================


//====================================================================
procedure csb_HUD_Init(); cdecl;
begin

  ocsb_HUD_Init();
end;
//====================================================================


//====================================================================
function csb_HUD_Redraw(flTime: Single; iIntermission: Longint):Longint;cdecl;
var
  g: Byte;
  cl_ent: cl_entity_s;
  pInfo: hud_player_info_t;
begin
  if bClientOnce = true then
  begin
    csb_DetourHook(pPreSDynamic, @csb_PreS_DynamicSound, 8, @ocsb_PreS_DynamicSound);

    //Place here your second initializations
    gMenu.AddMenuEntry('Wallhack', @gCvar.iWallhack, @WallhackProc);
    gMenu.AddMenuEntry('Teamglow', @gCvar.iTeamglow, @TeamglowProc);

    bClientOnce := false;
  end;

  for g := 0 to pEngFuncs.GetMaxClients() do
  begin
    cl_ent := pEngFuncs.GetEntityByIndex(g);
    if (cl_ent <> nil) and (cl_ent.player <> 0) then
    begin
      pEngFuncs.pfnGetPlayerInfo(g, @pInfo);

      gPlayer[g].client_handle := cl_ent^;
      gPlayer[g].name := pInfo.name;
      gPlayer[g].id := g;
      gPlayer[g].bSpectator := Boolean(cl_ent.curstate.spectator);

      if (lpCurrentGame = 'cstrike') or (lpCurrentGame = 'czero') then
        gPlayer[g].curWeapon := PChar(GetCsOrCzWeapon(cl_ent.curstate.weaponmodel))
      else if lpCurrentGame = 'valve' then
        gPlayer[g].curWeapon := PChar(GetHlWeapon(cl_ent.curstate.weaponmodel))
      else if lpCurrentGame = 'dod' then
        gPlayer[g].curWeapon := PChar(GetDodWeapon(cl_ent.curstate.weaponmodel))
      else if lpCurrentGame = 'tfc' then
        gPlayer[g].curWeapon := PChar(GetTfcWeapon(cl_ent.curstate.weaponmodel));

      gPlayer[g].origin := cl_ent.origin;

      if lpCurrentGame = 'valve' then
        gPlayer[g].team := tNone;

      if lpCurrentGame = 'dod' then
      begin
        if cl_ent.curstate.team = 1 then
          gPlayer[g].team := tAllies
        else if cl_ent.curstate.team = 2 then
          gPlayer[g].team := tAxis
        else if cl_ent.curstate.team = 3 then
          gPlayer[g].team := tBritain;
      end;
    end;
  end;

  if bDrawMenu then
    gMenu.DrawMenu;

  result := ocsb_HUD_Redraw(flTime, iIntermission);
end;
//====================================================================


//====================================================================
procedure csb_HUD_PlayerMove(pPMove: PlayerMove_s; bH: Longint);cdecl;
begin

  ocsb_HUD_PlayerMove(pPMove, bH);
end;
//====================================================================


//====================================================================
procedure csb_CL_CreateMove(frameTime: Single; UserCmd: usercmd_s; active: Longint);cdecl;
begin

  ocsb_CL_CreateMove(frameTime, UserCmd, active);
end;
//====================================================================


//====================================================================
procedure csb_V_CalcRefDef(pParams: ref_params_s);cdecl;
begin

  ocsb_V_CalcRefDef(pParams);
end;
//====================================================================


//====================================================================
function csb_HUD_AddEntity(itype: Integer; ent: cl_entity_s; modelname: PChar):LongInt;cdecl;
begin

  result := ocsb_HUD_AddEntity(itype, ent, modelname);
end;
//====================================================================


//====================================================================
procedure csb_HUD_PostRunCmd(from: Pointer; zTo: Pointer; UserCmd: usercmd_s; runfuncs: Integer; zTime: Single; random_seed: Word);cdecl;
begin

  ocsb_HUD_PostRunCmd(from, zTo, UserCmd, runfuncs, zTime, random_seed);
end;
//====================================================================


//====================================================================
function csb_HUD_Key_Event(eventCode: Integer; keynumb: Integer; pszCurrentBinding: PChar):Integer;cdecl;
begin
  if keynumb = iMenuKey then
    bDrawMenu := not bDrawMenu;

  if bDrawMenu then
    gMenu.KeyEvent(keynumb);

  result := ocsb_HUD_Key_Event(eventCode, keynumb, pszCurrentBinding);
end;
//====================================================================


//====================================================================
procedure csb_HookET;
begin
  while Assigned(oldExportTable.Initialize) <> true do
    Sleep(17);

  newExportTable := VirtualAlloc(nil, sizeof(ExportTable_t), MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  CopyMemory(newExportTable, oldExportTable, sizeof(ExportTable_t));

  ocsb_HUD_Init := @newExportTable.HUD_Init;
  oldExportTable.HUD_Init := @csb_HUD_Init;

  ocsb_HUD_Redraw := @newExportTable.HUD_Redraw;
  oldExportTable.HUD_Redraw := @csb_HUD_Redraw;

  ocsb_HUD_PlayerMove := @newExportTable.HUD_PlayerMove;
  oldExportTable.HUD_PlayerMove := @csb_HUD_PlayerMove;

  ocsb_CL_CreateMove := @newExportTable.CL_CreateMove;
  oldExportTable.CL_CreateMove := @csb_CL_CreateMove;

  ocsb_V_CalcRefDef := @newExportTable.V_CalcRefDef;
  oldExportTable.V_CalcRefdef := @csb_V_CalcRefDef;

  ocsb_HUD_AddEntity := @newExportTable.HUD_AddEntity;
  oldExportTable.HUD_AddEntity := @csb_HUD_AddEntity;

  ocsb_HUD_PostRunCmd := @newExportTable.HUD_PostRunCmd;
  oldExportTable.HUD_PostRunCmd := @csb_HUD_PostRunCmd;

  ocsb_HUD_Key_Event := @newExportTable.HUD_Key_Event;
  oldExportTable.HUD_Key_Event := @csb_HUD_Key_Event;
end;
//====================================================================


end.