unit csIniClass;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csIniClass.pas
  Description: INI file settings class

  Be sure to read the Readme.txt for more information
}

interface

uses
  SysUtils,
  Windows;

type
  TIniSet = class
    private
      lpFileName: String;
    public
	  constructor Create(lpIniFile: String; bCanCreate: LongBool);
      function SaveValue_Str(lpSection, lpKey, lpValue: String):LongBool;
      function ReadValue_Str(lpSection, lpKey: String):String;
      function SaveValue_Int(lpSection, lpKey: String; lpValue: Integer):LongBool;
      function ReadValue_Int(lpSection, lpKey: String):Integer;
end;

var gSettings: TIniSet;

implementation

constructor TIniSet.Create(lpIniFile: String; bCanCreate: LongBool);
begin
  lpFileName := lpIniFile;
  if FileExists(lpIniFile) <> true then
  begin
    if bCanCreate then
      CreateFile(PChar(lpIniFile), FILE_SHARE_WRITE, 0, nil, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, 0);
  end;
end;

function TIniSet.SaveValue_Str(lpSection, lpKey, lpValue: String):LongBool;
begin
  result := false;
  if (lpSection <> '') and (lpKey <> '') then
  begin
    result := WritePrivateProfileString(PChar(lpSection), PChar(lpKey), PChar(lpValue), PChar(lpFileName));
  end;
end;

function TIniSet.ReadValue_Str(lpSection, lpKey: String):String;
var
  iniBuffer: array[0..250] of Char;
begin
  result := '';
  if (lpSection <> '') and (lpKey <> '') then
  begin
    GetPrivateProfileString(PChar(lpSection), PChar(lpKey), '', @iniBuffer, sizeof(iniBuffer), PChar(lpFileName));
    result := iniBuffer;
  end;
end;

function TIniSet.SaveValue_Int(lpSection, lpKey: String; lpValue: Integer):LongBool;
begin
  result := false;
  if (lpSection <> '') and (lpKey <> '') then
  begin
    result := WritePrivateProfileString(PChar(lpSection), PChar(lpKey), PChar(inttostr(lpValue)), PChar(lpFileName));
  end;
end;

function TIniSet.ReadValue_Int(lpSection, lpKey: String):Integer;
begin
  result := -1000;
  if (lpSection <> '') and (lpKey <> '') then
  begin
    result := GetPrivateProfileInt(PChar(lpSection), PChar(lpKey), -1000, PChar(lpFileName));
  end;
end;

end.
