unit csMainHooks;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csMainHooks.pas
  Description: Main hooking code

  Be sure to read the Readme.txt for more information
}

interface

//====================================================================
uses
  SysUtils,
  Windows,
  csUsermsg,
  csEvents,
  csDetourHook,
  csExportTable,
  csEnginefuncs,
  uEngFuncs,
  csVars;
//====================================================================


//====================================================================
var bQueryOnce: Boolean = true;

var ocsb_OutputDebugStringA: procedure(lpOutputString: PChar);stdcall;
var ocsb_QueryPerformanceCounter: function(var lpPerformanceCount: TLargeInteger):LongBool;stdcall;
var ocsb_GetProcAddress: function(hMod: Cardinal; lpProcName: PChar):Pointer;stdcall;
//====================================================================


//====================================================================
procedure csb_HookMain;
procedure csb_OutputDebugStringA(lpOutputString: PChar);stdcall;
function csb_QueryPerformanceCounter(var lpPerformanceCount: TLargeInteger):LongBool;stdcall;
function csb_GetProcAddress(hMod: Cardinal; lpProcName: PChar):Pointer;stdcall;
//====================================================================

implementation

//====================================================================
procedure csb_OutputDebugStringA(lpOutputString: PChar);stdcall;
begin

  ocsb_OutputDebugStringA(lpOutputString);
end;
//====================================================================


//====================================================================
function csb_QueryPerformanceCounter(var lpPerformanceCount: TLargeInteger):LongBool;stdcall;
begin
  if bQueryOnce = true then
  begin
    ocsb_UserMsgHook := @pEngFuncs.pfnHookUserMsg;
    pEngFuncs.pfnHookUserMsg := @csb_HookUserMsg;

    ocsb_HookEvent := @pEngFuncs.pfnHookEvent;
    pEngFuncs.pfnHookEvent := @csb_HookEvent;

    bQueryOnce := false;
  end;

  result := ocsb_QueryPerformanceCounter(lpPerformanceCount);
end;
//====================================================================


//====================================================================
function csb_GetProcAddress(hMod: Cardinal; lpProcName: PChar):Pointer;stdcall;
var
  dwThreadID: DWord;
begin
  if HiWord(Cardinal(lpProcName)) <> Word(false) then
  begin
    if lstrcmpi(lpProcName, 'QueryPerformanceCounter') = 0 then
    begin
      result := @csb_QueryPerformanceCounter;
      exit;
    end;
    if lstrcmpi(lpProcName, 'HUD_GetStudioModelInterface') = 0 then
    begin
      CreateThread(nil, 0, @csb_HookET, nil, 0, dwThreadID);
      CreateThread(nil, 0, @csb_HookClientEngine, nil, 0, dwThreadID);
    end;
  end;
  
  result := ocsb_GetProcAddress(hMod, lpProcName);
end;
//====================================================================


//====================================================================
procedure csb_HookMain;
var
  hMod: Cardinal;
begin
  hMod := 0;

  while hMod = 0 do
  begin
    hMod := GetModuleHandle('kernel32.dll');

    if hMod <> 0 then
    begin
      ocsb_QueryPerformanceCounter := GetProcAddress(hMod, 'QueryPerformanceCounter');

      csb_DetourHook(GetProcAddress(hMod, 'GetProcAddress'), @csb_GetProcAddress, 5, @ocsb_GetProcAddress);
      csb_DetourHook(GetProcAddress(hMod, 'OutputDebugStringA'), @csb_OutputDebugStringA, 5, @ocsb_OutputDebugStringA);
    end;
  end;
end;
//====================================================================

end.