unit csOpenGL;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csOpenGL.pas
  Description: OpenGL hooks

  Be sure to read the Readme.txt for more information
}

interface

//====================================================================
uses
  SysUtils,
  Windows,
  uEngFuncs,
  csDetourHook,
  csUtilities,
  csVars,
  OpenGL;
//====================================================================


//====================================================================
var ocsb_glBegin: procedure(mode: Cardinal);stdcall;
var ocsb_glBlendFunc: procedure(sFactor: Cardinal; dFactor: Cardinal);stdcall;
var ocsb_glClear: procedure(mask: Cardinal);stdcall;
var ocsb_glEnable: procedure(cap: Cardinal);stdcall;
var ocsb_glEnd: procedure();stdcall;
var ocsb_glPushMatrix: procedure();stdcall;
var ocsb_glPopMatrix: procedure();stdcall;
var ocsb_glVertex2f: procedure(x: Single; y: Single);stdcall;
var ocsb_glVertex3f: procedure(x: Single; y: Single; z: Single);stdcall;
var ocsb_glVertex3fv: procedure(v: PGLfloat);stdcall;
var ocsb_glViewport: procedure(x: integer; y: integer; width: integer; heigth: integer);stdcall;

var bGlBeginOnce: Boolean = true;
//====================================================================


//====================================================================
procedure csb_HookGlProcs;stdcall;
//====================================================================

implementation

//====================================================================
procedure csb_glBegin(mode: Cardinal);stdcall;
var
  arrViewport: array[0..3] of GLuint;
  g: Byte;
  col_ent: cl_entity_s;
begin
  if bGlBeginOnce = true then
  begin
    //Place here your first initializations
    GlGetIntegerv(GL_VIEWPORT, @arrViewport);
    iCenterX := arrViewport[2] div 2;
    iCenterY := arrViewport[3] div 2;

    lpCurrentGame := GetCurrentMod;

    bGlBeginOnce := false;
  end;

  //Wallhack example:
  if gCvar.iWallhack = 1 then
  begin
    if (mode = GL_TRIANGLE_FAN) or (mode = GL_TRIANGLE_STRIP) then
      glDisable(GL_DEPTH_TEST);
  end;

  //Teamglow example:
  if gCvar.iTeamglow = 1 then
  begin
    for g := 0 to pEngFuncs.GetMaxClients() do
    begin
      col_ent := pEngFuncs.GetEntityByIndex(g);
      if (lpCurrentGame = 'cstrike') or (lpCurrentGame = 'czero') then
      begin
        if gPlayer[g].team = tCounter then
          SetPlayerGlow(col_ent, 0, 0, 250, 1)
        else if gPlayer[g].team = tTerror then
          SetPlayerGlow(col_ent, 250, 0, 0, 1);
      end
      else if lpCurrentGame = 'valve' then
      begin
        if gPlayer[g].team = tNone then
          SetPlayerGlow(col_ent, 120, 77, 114, 1);
      end
      else if lpCurrentGame = 'dod' then
      begin
        if gPlayer[g].team = tAllies then
          SetPlayerGlow(col_ent, 0, 0, 250, 1)
        else if gPlayer[g].team = tAxis then
          SetPlayerGlow(col_ent, 250, 0, 0, 1)
        else if gPlayer[g].team = tBritain then
          SetPlayerGlow(col_ent, 0, 250, 0, 1);
      end;
    end;
  end;

  ocsb_glBegin(mode);
end;
//====================================================================


//====================================================================
procedure csb_glBlendFunc(sFactor: Cardinal; dFactor: Cardinal);stdcall;
begin

  ocsb_glBlendFunc(sFactor, dFactor);
end;
//====================================================================


//====================================================================
procedure csb_glClear(mask: Cardinal);stdcall;
begin

  ocsb_glClear(mask);
end;
//====================================================================


//====================================================================
procedure csb_glEnable(cap: Cardinal);stdcall;
begin

  ocsb_glEnable(cap);
end;
//====================================================================


//====================================================================
procedure csb_glEnd();stdcall;
begin

  ocsb_glEnd();
end;
//====================================================================


//====================================================================
procedure csb_glPushMatrix();stdcall;
begin

  ocsb_glPushMatrix();
end;
//====================================================================


//====================================================================
procedure csb_glPopMatrix();stdcall;
begin

  ocsb_glPopMatrix();
end;
//====================================================================


//====================================================================
procedure csb_glVertex2f(x: Single; y: Single);stdcall;
begin
  
  ocsb_glVertex2f(x, y);
end;
//====================================================================


//====================================================================
procedure csb_glVertex3f (x: Single; y: Single; z: Single);stdcall;
begin

  ocsb_glVertex3f(x, y, z);
end;
//====================================================================


//====================================================================
procedure csb_glVertex3fv (v: PGLfloat);stdcall;
begin

  ocsb_glVertex3fv(v);
end;
//====================================================================


//====================================================================
procedure csb_glViewport(x: integer; y: integer; width: integer; heigth: integer);stdcall;
begin

  ocsb_glViewport(x, y, width, heigth);
end;
//====================================================================


//====================================================================
procedure csb_HookGlProcs;stdcall;
var
  hModule: Cardinal;
begin
  hModule := 0;

  while hModule = 0 do
  begin
    hModule := GetModuleHandle('opengl32.dll');

    if hModule <> 0 then
    begin
      csb_DetourHook(GetProcAddress(hModule, 'glBegin'), @csb_glBegin, 6, @ocsb_glBegin);
      csb_DetourHook(GetProcAddress(hModule, 'glBlendFunc'), @csb_glBlendFunc, 7, @ocsb_glBlendFunc);
      csb_DetourHook(GetProcAddress(hModule, 'glClear'), @csb_glClear, 7, @ocsb_glClear);
      csb_DetourHook(GetProcAddress(hModule, 'glEnable'), @csb_glEnable, 6, @ocsb_glEnable);
      csb_DetourHook(GetProcAddress(hModule, 'glEnd'), @csb_glEnd, 6, @ocsb_glEnd);
      csb_DetourHook(GetProcAddress(hModule, 'glPushMatrix'), @csb_glPushMatrix, 6, @ocsb_glPushMatrix);
      csb_DetourHook(GetProcAddress(hModule, 'glPopMatrix'), @csb_glPopMatrix, 6, @ocsb_glPopMatrix);
      csb_DetourHook(GetProcAddress(hModule, 'glVertex2f'), @csb_glVertex2f, 6, @ocsb_glVertex2f);
      csb_DetourHook(GetProcAddress(hModule, 'glVertex3f'), @csb_glVertex3f, 6, @ocsb_glVertex3f);
      csb_DetourHook(GetProcAddress(hModule, 'glVertex3fv'), @csb_glVertex3fv, 6, @ocsb_glVertex3fv);
      csb_DetourHook(GetProcAddress(hModule, 'glViewport'), @csb_glViewport, 7, @ocsb_glViewport);
    end;

    Sleep(17);
  end;
end;
//====================================================================

end.