library csSkored;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines

  File: csSkored.dpr
  Description: DLL Main

  Be sure to read the Readme.txt for more information
}


//====================================================================
uses
  SysUtils,
  Windows,
  Classes,
  csEnginefuncs in 'csEnginefuncs.pas',
  csEvents in 'csEvents.pas',
  csExportTable in 'csExportTable.pas',
  csLogClass in 'csLogClass.pas',
  csMainHooks in 'csMainHooks.pas',
  csOpenGL in 'csOpenGL.pas',
  csSound in 'csSound.pas',
  csUsermsg in 'csUsermsg.pas',
  uEngFuncs in 'uEngFuncs.pas',
  csVars in 'csVars.pas',
  csDetourHook in 'csDetourHook.pas',
  csUtilities in 'csUtilities.pas',
  csIniClass in 'csIniClass.pas',
  csMenuClass in 'csMenuClass.pas';

//====================================================================


//====================================================================
var dwHookThreadID: Cardinal = 0;
//====================================================================


//====================================================================
procedure SetPathVariables(hInstDll: Cardinal);
begin
  GetModuleFileName(hInstDll, lpSelfFileName, sizeof(lpSelfFileName));
  lpModulePath := ExtractFilePath(lpSelfFileName);
  lpIniFile := ExtractFilePath(lpSelfFileName) + '\Settings.ini';
end;
//====================================================================


//====================================================================
procedure DllMain(fdwReason: DWord);
begin
  if fdwReason = DLL_PROCESS_ATTACH then
  begin
    SetPathVariables(hInstance);

    gLog := TLog.Create('CzySkored_Base.log');
    gIni := TIniSet.Create(lpIniFile, false);

    iMenuKey := gIni.ReadValue_Int('Keys', 'MenuKey'); 

    iEngFuncs := strtoint(gIni.ReadValue_Str('Offsets', 'pEngFuncs'));
    iEngStudio := strtoint(gIni.ReadValue_Str('Offsets', 'pEngStudio'));
    iExportTable := strtoint(gIni.ReadValue_Str('Offsets', 'pExportTable'));
    iPreSDynamic := strtoint(gIni.ReadValue_Str('Offsets', 'pPreSDynamic'));

    pEngFuncs := cl_enginefuncs_s(iEngFuncs);
    pEngStudio := engine_studio_api_s(iEngStudio);
    oldExportTable := ExportTable_s(iExportTable);
    pPreSDynamic := Pointer(iPreSDynamic);

    gBorder.r := 110; gBorder.g := 0; gBorder.b := 0; gBorder.a := 150;
    gHeadline.r := 0; gHeadline.g := 150; gHeadline.b := 0; gHeadline.a := 150;
    gBody.r := 0; gBody.g := 77; gBody.b := 0; gBody.a := 150;
    gMenu := TCzyMenu.Create('CzySkored-Base', 200, 220, gBorder, gHeadline, gBody, 114, iEngFuncs);

    gCvar.iWallhack := gIni.ReadValue_Int('Hacks', 'Wallhack');
    gCvar.iTeamglow := gIni.ReadValue_Int('Hacks', 'Teamglow');

    CreateThread(nil, 0, @csb_HookMain, nil, 0, dwHookThreadID);
    CreateThread(nil, 0, @csb_HookGlProcs, nil, 0, dwHookThreadID);
  end
  else if fdwReason = DLL_PROCESS_DETACH then
  begin
    gLog.Free;
    gIni.Free;
    gMenu.Free;
  end;
end;
//====================================================================


//====================================================================
exports
  DllMain;
//====================================================================


//====================================================================
begin
  DllProc := @DllMain;
  DllMain(DLL_PROCESS_ATTACH);
end.
//====================================================================
