unit csUtilities;

{
  CzySkored-Base coded by sk0r / Czybik

  Features:
    - OpenGL
    - Exporttable
    - Usermsg
    - Events
    - Enginefuncs
    - PreS_DynamicSound
    - Log Class
    - Ini Class
    - Menu Class
    - Useful routines
    
  File: csUtilities.pas
  Description: Utility routines

  Be sure to read the Readme.txt for more information
}

interface

//====================================================================
uses
  SysUtils,
  Windows,
  uEngFuncs,
  csVars,
  czyStrings;
//====================================================================


//====================================================================
function WhichTeam(lpcModel: PChar): Integer;
procedure ExecConfig(lpConfig: string);
function IsEnemyBehindWall(pEntStart, pEntEnd: cl_entity_s):Boolean;
function HasValidWeapon():Boolean;
function GetCurrentWeapon():PChar;
function HasValidAimbotWeapon():LongBool;
function HasValidSpeedWeapon:LongBool;
function GetCurrentMod:String;
procedure fTextPrint(lpText: String; x, y: Integer; r, g, b: Single);
procedure sTextPrint(lpText: String; x, y: Integer; r, g, b: Integer);
procedure SetPlayerGlow(pPlayer: cl_entity_s; red, green, blue: Byte; iThickness: Integer);
procedure SetThirdperson(bOn: Boolean);
function GetCsOrCzWeapon(lpWeaponId: Integer):String;
function GetHlWeapon(lpWeaponId: Integer):String;
function GetDoDWeapon(lpWeaponId: Integer):String;
function GetTfcWeapon(lpWeaponId: Integer):String;
//====================================================================

implementation

//====================================================================


//====================================================================
function WhichTeam(lpcModel: PChar): Integer;
begin
  result := 0;
  if (Pos('arctic', lpcModel) <> 0) or (Pos('guerilla', lpcModel) <> 0) or (Pos('leet', lpcModel) <> 0) or (Pos('terror', lpcModel) <> 0) then
  begin
    result := 2; 
  end
  else if (Pos('gign', lpcModel) <> 0) or (Pos('gsg9', lpcModel) <> 0) or (Pos('sas', lpcModel) <> 0) or (Pos('urban', lpcModel) <> 0) or (Pos('vip', lpcModel) <> 0) then
  begin
    result := 1; 
  end;
end;
//====================================================================


//====================================================================
procedure ExecConfig(lpConfig: string);
var
  fHandler: Textfile;
  lnText: string;
begin
	if (Right(lpConfig, 3) <> '.cfg') and (Right(lpConfig, 2) <> '.rc') then exit;
	AssignFile(fHandler, lpConfig);
	Reset(fHandler);
	while not eof(fHandler) do
	begin
		Readln(fHandler, lnText);
		if lnText <> '' then
		begin
			pEngFuncs.pfnClientCmd(PChar(lnText));
		end;
	end;
	CloseFile(fHandler);
end;
//====================================================================


//====================================================================
function IsEnemyBehindWall(pEntStart, pEntEnd: cl_entity_s):Boolean;
var
  pmTraceVis: pmtrace_s; 
begin
  pmTraceVis := pEngFuncs.PM_TraceLine(@pEntStart.origin, @pEntEnd.origin, 0, 2, -1);
  if pmTraceVis^.fraction >= 1.0 then 
  begin
    result := false;
  end
  else begin
    result := true;
  end;
end;
//====================================================================


//====================================================================
function HasValidWeapon():Boolean;
var
  lpWeaponName: PChar;
begin
  lpWeaponName := pEngFuncs.GetViewModel().model.name;
  if (Pos('c4', lpWeaponName) <> 0) or (Pos('hegrenade', lpWeaponName) <> 0) 
    or (Pos('flash', lpWeaponName) <> 0) or (Pos('smokegrenade', lpWeaponName) <> 0) then 
  begin
    result := false;
  end
  else begin
    result := true;
  end;
end;
//====================================================================


//====================================================================
function GetCurrentWeapon():PChar;
begin
  result := pEngFuncs.GetViewModel().model.name;
end;
//====================================================================


//====================================================================
function HasValidAimbotWeapon():LongBool;
var
  lpWeaponName: PChar;
begin
  lpWeaponName := pEngFuncs.GetViewModel().model.name;
  if (Pos('c4', lpWeaponName) <> 0) or (Pos('hegrenade', lpWeaponName) <> 0)
    or (Pos('flash', lpWeaponName) <> 0) or (Pos('smokegrenade', lpWeaponName) <> 0) then
    result := false
  else 
    result := true;
end;
//====================================================================


//====================================================================
function HasValidSpeedWeapon:LongBool;
var
  lpWeaponName: PChar;
begin
  lpWeaponName := pEngFuncs.GetViewModel().model.name;
  if Pos('knife', lpWeaponName) <> 0 then
    result := true
  else
    result := false;
end;
//====================================================================


//====================================================================
function GetCurrentMod:String;
begin
  result := strpas(pEngFuncs.pfnGetGameDirectory());
end;
//====================================================================


//====================================================================
procedure fTextPrint(lpText: String; x, y: Integer; r, g, b: Single);
begin
  if lpText <> '' then
  begin
    pEngFuncs.pfnDrawSetTextColor(r, g, b);
    pEngFuncs.pfnDrawConsoleString(x, y, PChar(lpText));
  end;
end;
//====================================================================


//====================================================================
procedure sTextPrint(lpText: String; x, y: Integer; r, g, b: Integer);
var
  h: Byte;
begin
  if lpText <> '' then
  begin
    for h := 1 to length(lpText) do
      pEngFuncs.pfnDrawCharacter(x + (h*10), y, Ord(lpText[h]), r, g, b);
  end;
end;
//====================================================================


//====================================================================
procedure SetPlayerGlow(pPlayer: cl_entity_s; red, green, blue: Byte; iThickness: Integer);
begin
  if (pPlayer <> nil) and (pPlayer.player <> 0) then
  begin
    pPlayer.curstate.renderfx := kRenderFxGlowShell;
    pPlayer.curstate.renderamt := iThickness;
    pPlayer.curstate.rendercolor.r := red;
    pPlayer.curstate.rendercolor.g := green;
    pPlayer.curstate.rendercolor.b := blue;
  end;
end;
//====================================================================


//====================================================================
procedure SetThirdperson(bOn: Boolean);
var
  pCA: cvar_s;
  pRD: cvar_s;
begin
  pCA := pEngFuncs.pfnGetCvarPointer('chase_active');
  pRD := pEngFuncs.pfnGetCvarPointer('r_drawviewmodel');
  if (pCA <> nil) and (pRD <> nil) then
  begin
    if bOn then
    begin
      pCA.value := 1.0;
      pRD.value := 0.0;
    end
    else if not bOn then
    begin
      pCA.value := 0.0;
      pRD.value := 1.0;
    end;
  end;
end;
//====================================================================


//====================================================================
function GetCsOrCzWeapon(lpWeaponId: Integer):String;
var
  pModel: model_s;
begin
  result := 'N/A';
  pModel := pEngStudio.GetModelByIndex(lpWeaponId);
  if pModel <> nil then
  begin
    if lstrcmpi(pModel^.name, 'models/p_ak47.mdl') = 0 then
    begin
      result := 'Kalashnikov';
    end;
    if lstrcmpi(pModel^.name, 'models/p_smokegrenade.mdl') = 0 then
    begin
      result := 'Smokegrenade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_aug.mdl') = 0 then
    begin
      result := 'Steyr AUG';
    end;
    if lstrcmpi(pModel^.name, 'models/p_awp.mdl') = 0 then
    begin
      result := 'Magnum AWP';
    end;
    if lstrcmpi(pModel^.name, 'models/p_c4.mdl') = 0 then
    begin
      result := 'C4 Bomb';
    end;
    if lstrcmpi(pModel^.name, 'models/p_deagle.mdl') = 0 then
    begin
      result := 'Desert Eagle';
    end;
    if lstrcmpi(pModel^.name, 'models/p_elite.mdl') = 0 then
    begin
      result := 'Elite';
    end;
    if lstrcmpi(pModel^.name, 'models/p_famas.mdl') = 0 then
    begin
      result := 'Famas';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fiveseven.mdl') = 0 then
    begin
      result := 'Fiveseven';
    end;
    if lstrcmpi(pModel^.name, 'models/p_flashbang.mdl') = 0 then
    begin
      result := 'Flashbang';
    end;
    if lstrcmpi(pModel^.name, 'models/p_g3sg1.mdl') = 0 then
    begin
      result := 'G3SG1 Sniper';
    end;
    if lstrcmpi(pModel^.name, 'models/p_galil.mdl') = 0 then
    begin
      result := 'Galil';
    end;
    if lstrcmpi(pModel^.name, 'models/p_glock18.mdl') = 0 then
    begin
      result := 'Glock';
    end;
    if lstrcmpi(pModel^.name, 'models/p_hegrenade.mdl') = 0 then
    begin
      result := 'HE-Grenade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_knife.mdl') = 0 then
    begin
      result := 'Knife';
    end;
    if lstrcmpi(pModel^.name, 'models/p_m249.mdl') = 0 then
    begin
      result := 'M294';
    end;
    if lstrcmpi(pModel^.name, 'models/p_m3.mdl') = 0 then
    begin
      result := 'M3 Shotgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_m4a1.mdl') = 0 then
    begin
      result := 'M4A1 Rifle';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mac10.mdl') = 0 then
    begin
      result := 'MAC10 Uzi';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mp5.mdl') = 0 then
    begin
      result := 'MP5';
    end;
    if lstrcmpi(pModel^.name, 'models/p_p228.mdl') = 0 then
    begin
      result := 'P228';
    end;
    if lstrcmpi(pModel^.name, 'models/p_p90.mdl') = 0 then
    begin
      result := 'P90';
    end;
    if lstrcmpi(pModel^.name, 'models/p_scout.mdl') = 0 then
    begin
      result := 'Scout';
    end;
    if lstrcmpi(pModel^.name, 'models/p_sg550.mdl') = 0 then
    begin
      result := 'SG550';
    end;
    if lstrcmpi(pModel^.name, 'models/p_sg552.mdl') = 0 then
    begin
      result := 'SG552';
    end;
    if lstrcmpi(pModel^.name, 'models/p_shield.mdl') = 0 then
    begin
      result := 'Tactical Shield';
    end;
    if lstrcmpi(pModel^.name, 'models/p_tmp.mdl') = 0 then
    begin
      result := 'TMP';
    end;
    if lstrcmpi(pModel^.name, 'models/p_ump45.mdl') = 0 then
    begin
      result := 'UMP45';
    end;
    if lstrcmpi(pModel^.name, 'models/p_usp.mdl') = 0 then
    begin
      result := 'USP Pistol';
    end;
    if lstrcmpi(pModel^.name, 'models/p_xm1014.mdl') = 0 then
    begin
      result := 'XM1014';
    end;
  end;
end;
//====================================================================


//====================================================================
function GetHlWeapon(lpWeaponId: Integer):String;
var
  pModel: model_s;
begin
  result := 'N/A';
  pModel := pEngStudio.GetModelByIndex(lpWeaponId);
  if pModel <> nil then
  begin
    if lstrcmpi(pModel^.name, 'models/p_357.mdl') = 0 then
    begin
      result := 'Pistol 357';
    end;
    if lstrcmpi(pModel^.name, 'models/p_9mmar.mdl') = 0 then
    begin
      result := 'Pistol 9mm';
    end;
    if lstrcmpi(pModel^.name, 'models/p_9mmhandgun.mdl') = 0 then
    begin
      result := 'Handgun 9mm';
    end;
    if lstrcmpi(pModel^.name, 'models/p_crossbow.mdl') = 0 then
    begin
      result := 'Crossbow';
    end;
    if lstrcmpi(pModel^.name, 'models/p_egon.mdl') = 0 then
    begin
      result := 'EGon';
    end;
    if lstrcmpi(pModel^.name, 'models/p_gauss.mdl') = 0 then
    begin
      result := 'Gauss';
    end;
    if lstrcmpi(pModel^.name, 'models/p_glock.mdl') = 0 then
    begin
      result := 'Glock';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grenade.mdl') = 0 then
    begin
      result := 'Grenade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_hgun.mdl') = 0 then
    begin
      result := 'HGun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_rpg.mdl') = 0 then
    begin
      result := 'RPG-Gun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_shotgun.mdl') = 0 then
    begin
      result := 'Shotgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_tripmine.mdl') = 0 then
    begin
      result := 'Tripmine';
    end;
    if lstrcmpi(pModel^.name, 'models/p_squeak.mdl') = 0 then
    begin
      result := 'Squeak';
    end;
    if lstrcmpi(pModel^.name, 'models/p_satchel.mdl') = 0 then
    begin
      result := 'Satchel';
    end;
    if lstrcmpi(pModel^.name, 'models/p_satchel_radio.mdl') = 0 then
    begin
      result := 'Satchel Radio';
    end;
  end;
end;
//====================================================================


//====================================================================
function GetDoDWeapon(lpWeaponId: Integer):String;
var
  pModel: model_s;
begin
  result := 'N/A';
  pModel := pEngStudio.GetModelByIndex(lpWeaponId);
  if pModel <> nil then
  begin
    if lstrcmpi(pModel^.name, 'models/p_30cal.mdl') = 0 then
    begin
      result := '30Cal';
    end;
    if lstrcmpi(pModel^.name, 'models/p_30calpr.mdl') = 0 then
    begin
      result := '30Calpr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_30calr.mdl') = 0 then
    begin
      result := '30Calr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_30calsr.mdl') = 0 then
    begin
      result := '30Calsr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_amerk.mdl') = 0 then
    begin
      result := 'Amerk';
    end;
    if lstrcmpi(pModel^.name, 'models/p_barbd.mdl') = 0 then
    begin
      result := 'Barbd';
    end;
    if lstrcmpi(pModel^.name, 'models/p_barbu.mdl') = 0 then
    begin
      result := 'Barbu';
    end;
    if lstrcmpi(pModel^.name, 'models/p_bazooka.mdl') = 0 then
    begin
      result := 'Bazooka';
    end;
    if lstrcmpi(pModel^.name, 'models/p_bazooka_l.mdl') = 0 then
    begin
      result := 'Bazooka L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_bren.mdl') = 0 then
    begin
      result := 'Bren';
    end;
    if lstrcmpi(pModel^.name, 'models/p_bren_l.mdl') = 0 then
    begin
      result := 'G3SG1 Sniper';
    end;
    if lstrcmpi(pModel^.name, 'models/p_brenbd.mdl') = 0 then
    begin
      result := 'Brenbd';
    end;
    if lstrcmpi(pModel^.name, 'models/p_brenbr.mdl') = 0 then
    begin
      result := 'Brenbr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_brenpr.mdl') = 0 then
    begin
      result := 'Brenpr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_brenbu.mdl') = 0 then
    begin
      result := 'Brenbu';
    end;
    if lstrcmpi(pModel^.name, 'models/p_brensr.mdl') = 0 then
    begin
      result := 'Brensr';
    end;
    if lstrcmpi(pModel^.name, 'models/p_colt.mdl') = 0 then
    begin
      result := 'Colt';
    end;
    if lstrcmpi(pModel^.name, 'models/p_enfield.mdl') = 0 then
    begin
      result := 'Enfield';
    end;
    if lstrcmpi(pModel^.name, 'models/p_enfield_l.mdl') = 0 then
    begin
      result := 'Enfield L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_enfields.mdl') = 0 then
    begin
      result := 'Enfields';
    end;
    if lstrcmpi(pModel^.name, 'models/p_enfields_l.mdl') = 0 then
    begin
      result := 'Enfields L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fairbairn.mdl') = 0 then
    begin
      result := 'Fairbairn';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fcarb.mdl') = 0 then
    begin
      result := 'FCarb';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fcarb_l.mdl') = 0 then
    begin
      result := 'FCarb L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42.mdl') = 0 then
    begin
      result := 'FG42';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42bd.mdl') = 0 then
    begin
      result := 'FG42BD';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42BU.mdl') = 0 then
    begin
      result := 'FG42BU';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42pr.mdl') = 0 then
    begin
      result := 'FG42PR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42s.mdl') = 0 then
    begin
      result := 'FG42S';
    end;
    if lstrcmpi(pModel^.name, 'models/p_fg42sr.mdl') = 0 then
    begin
      result := 'FG42SR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_garand.mdl') = 0 then
    begin
      result := 'Garand';
    end;
    if lstrcmpi(pModel^.name, 'models/p_garand_l.mdl') = 0 then
    begin
      result := 'Garand L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grease.mdl') = 0 then
    begin
      result := 'GREase';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grease_l.mdl') = 0 then
    begin
      result := 'GREase L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grenade.mdl') = 0 then
    begin
      result := 'Grenade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_k43.mdl') = 0 then
    begin
      result := 'K43';
    end;
    if lstrcmpi(pModel^.name, 'models/p_k98.mdl') = 0 then
    begin
      result := 'K98';
    end;
    if lstrcmpi(pModel^.name, 'models/p_k98_l.mdl') = 0 then
    begin
      result := 'K98 L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_k98s.mdl') = 0 then
    begin
      result := 'K98S';
    end;
    if lstrcmpi(pModel^.name, 'models/p_k98s_l.mdl') = 0 then
    begin
      result := 'K98S L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_luger.mdl') = 0 then
    begin
      result := 'Luger';
    end;
    if lstrcmpi(pModel^.name, 'models/p_m1carb.mdl') = 0 then
    begin
      result := 'M1Carb';
    end;
    if lstrcmpi(pModel^.name, 'models/p_m1carb_l.mdl') = 0 then
    begin
      result := 'M1Carb L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg34bd.mdl') = 0 then
    begin
      result := 'MG34BD';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg34bu.mdl') = 0 then
    begin
      result := 'MG34BU';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg34pr.mdl') = 0 then
    begin
      result := 'MG34PR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg34sr.mdl') = 0 then
    begin
      result := 'MG34SR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg42bd.mdl') = 0 then
    begin
      result := 'MG42BD';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg42bu.mdl') = 0 then
    begin
      result := 'MG42BU';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg42pr.mdl') = 0 then
    begin
      result := 'MG42PR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mg42sr.mdl') = 0 then
    begin
      result := 'MG42SR';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mills.mdl') = 0 then
    begin
      result := 'Mills';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mortar.mdl') = 0 then
    begin
      result := 'Mortar';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mp40.mdl') = 0 then
    begin
      result := 'MP40';
    end;
    if lstrcmpi(pModel^.name, 'models/p_paraknife.mdl') = 0 then
    begin
      result := 'Paraknife';
    end;
    if lstrcmpi(pModel^.name, 'models/p_piat.mdl') = 0 then
    begin
      result := 'Piat';
    end;
    if lstrcmpi(pModel^.name, 'models/p_pschreck.mdl') = 0 then
    begin
      result := 'PSchreck';
    end;
    if lstrcmpi(pModel^.name, 'models/p_pscheck_l.mdl') = 0 then
    begin
      result := 'PSchreck L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_satchel.mdl') = 0 then
    begin
      result := 'Satchel';
    end;
    if lstrcmpi(pModel^.name, 'models/p_scopedfg42bu.mdl') = 0 then
    begin
      result := 'Scopedfg 42 bu';
    end;
    if lstrcmpi(pModel^.name, 'models/p_spade.mdl') = 0 then
    begin
      result := 'Spade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_spring.mdl') = 0 then
    begin
      result := 'Spring';
    end;
    if lstrcmpi(pModel^.name, 'models/p_sten.mdl') = 0 then
    begin
      result := 'Sten L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_stg44.mdl') = 0 then
    begin
      result := 'STG44';
    end;
    if lstrcmpi(pModel^.name, 'models/p_stick.mdl') = 0 then
    begin
      result := 'Stick';
    end;
    if lstrcmpi(pModel^.name, 'models/p_tommy.mdl') = 0 then
    begin
      result := 'Tommy';
    end;
    if lstrcmpi(pModel^.name, 'models/p_tommy_l.mdl') = 0 then
    begin
      result := 'Tommy L';
    end;
    if lstrcmpi(pModel^.name, 'models/p_webley.mdl') = 0 then
    begin
      result := 'Webley';
    end;
    if lstrcmpi(pModel^.name, 'models/p_youthk.mdl') = 0 then
    begin
      result := 'Youthk';
    end;
  end;
end;
//====================================================================


//====================================================================
function GetTfcWeapon(lpWeaponId: Integer):String;
var
  pModel: model_s;
begin
  result := 'N/A';
  pModel := pEngStudio.GetModelByIndex(lpWeaponId);
  if pModel <> nil then
  begin
    if lstrcmpi(pModel^.name, 'models/p_9mmhandgun.mdl') = 0 then
    begin
      result := '9mm Handgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_9mmhandgun2.mdl') = 0 then
    begin
      result := '9mm Handgun2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_crowbar.mdl') = 0 then
    begin
      result := 'Crowbar';
    end;
    if lstrcmpi(pModel^.name, 'models/p_crowbar2.mdl') = 0 then
    begin
      result := 'Crowbar2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_egon.mdl') = 0 then
    begin
      result := 'Egon';
    end;
    if lstrcmpi(pModel^.name, 'models/p_egon2.mdl') = 0 then
    begin
      result := 'Egon2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_glauncher.mdl') = 0 then
    begin
      result := 'Grenade Launcher';
    end;
    if lstrcmpi(pModel^.name, 'models/p_glauncher2.mdl') = 0 then
    begin
      result := 'Grenade Launcher2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grenade.mdl') = 0 then
    begin
      result := 'Grenade';
    end;
    if lstrcmpi(pModel^.name, 'models/p_grenade2.mdl') = 0 then
    begin
      result := 'Grenade2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_knife.mdl') = 0 then
    begin
      result := 'Knife';
    end;
    if lstrcmpi(pModel^.name, 'models/p_knife2.mdl') = 0 then
    begin
      result := 'Knife2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_medkit.mdl') = 0 then
    begin
      result := 'Medikit';
    end;
    if lstrcmpi(pModel^.name, 'models/p_medkit2.mdl') = 0 then
    begin
      result := 'Medikit2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mini.mdl') = 0 then
    begin
      result := 'Mini';
    end;
    if lstrcmpi(pModel^.name, 'models/p_mini2.mdl') = 0 then
    begin
      result := 'Mini2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_nailgun.mdl') = 0 then
    begin
      result := 'Nailgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_nailgun2.mdl') = 0 then
    begin
      result := 'Nailgun2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_rpg.mdl') = 0 then
    begin
      result := 'RPG';
    end;
    if lstrcmpi(pModel^.name, 'models/p_rpg2.mdl') = 0 then
    begin
      result := 'RPG2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_shotgun.mdl') = 0 then
    begin
      result := 'Shotgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_shotgun2.mdl') = 0 then
    begin
      result := 'Shotgun2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_smallshotgun.mdl') = 0 then
    begin
      result := 'Small shotgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_snailgun.mdl') = 0 then
    begin
      result := 'SNailgun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_snailgun2.mdl') = 0 then
    begin
      result := 'SNailgun2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_sniper.mdl') = 0 then
    begin
      result := 'Sniper';
    end;
    if lstrcmpi(pModel^.name, 'models/p_sniper2.mdl') = 0 then
    begin
      result := 'Sniper2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_spanner.mdl') = 0 then
    begin
      result := 'Spanner';
    end;
    if lstrcmpi(pModel^.name, 'models/p_spanner2.mdl') = 0 then
    begin
      result := 'Spanner2';
    end;
    if lstrcmpi(pModel^.name, 'models/p_spygun.mdl') = 0 then
    begin
      result := 'Spygun';
    end;
    if lstrcmpi(pModel^.name, 'models/p_srpg.mdl') = 0 then
    begin
      result := 'SRPG';
    end;
    if lstrcmpi(pModel^.name, 'models/p_umbrella.mdl') = 0 then
    begin
      result := 'Umbrella';
    end;
    if lstrcmpi(pModel^.name, 'models/p_umbrella2.mdl') = 0 then
    begin
      result := 'Umbrella2';
    end;
  end;
end;
//====================================================================

end.