unit czyStrings;

//czyStrings.pas - Simple String handlers by sk0r / Czybik (v0.1)

interface

uses SysUtils, Classes;

type TBindString = array[0..2] of String;

function Left(szLString: string; iLCount: Cardinal):String;
function Right(szRString: string; iRCount: Cardinal):String;
function Mid(szMString: string; iMCount: Cardinal):String;
function StringReversion(lpTargetStr: String):String;
function FilterText(lpText, lpStart, lpEnd: String):String;
function FilterVar(lpText: String; lpChar: Char):String;
function Split(lpTextStr: String; lpSplitChar: String; bTrim: Boolean; bQuotes: Boolean):TStringList;
procedure FilterVar2(lpLineStr: String; var gBindString: TBindString);
function ExtractEmailFromHtml(lpLineStr: String):String;

implementation

function Left(szLString: string; iLCount: Cardinal):String;
begin
	result := Copy(szLString, 1, Integer(iLCount));
end;

function Right(szRString: string; iRCount: Cardinal):String;
begin
	result := Copy(szRString, length(szRString) - Integer(iRCount) + 1, iRCount + 1);
end;

function Mid(szMString: string; iMCount: Cardinal):String;
begin
  result := Copy(szMString, Integer(iMCount), 1);
end;

function StringReversion(lpTargetStr: String):String;
var
  g: Integer;
begin
  result := '';
  for g := length(lpTargetStr) downto 1 do
    result := result + lpTargetStr[g];
end;

function FilterText(lpText, lpStart, lpEnd: String):String;
var
  g: Integer;
begin
  result := '';
  for g := Pos(lpStart, lpText) + 1 to Pos(lpEnd, lpText) - 1 do
  begin
    result := result + lpText[g];
  end;
end;

function FilterVar(lpText: String; lpChar: Char):String;
var
  g: Integer;
begin
  result := '';
  for g := Pos(lpChar, lpText) + 1 to length(lpText) do
  begin
    if lpText[g] = lpChar then break;
    result := result + lpText[g];
  end;
end;

function Split(lpTextStr: String; lpSplitChar: String; bTrim: Boolean; bQuotes: Boolean):TStringList;
var
  g: Integer;
  TempTrash: String;
  CurTemp: String;
begin
  result := TStringList.Create;
  TempTrash := '';
  lpTextStr := lpTextStr + lpSplitChar;
  for g := 1 to length(lpTextStr) do
  begin
    TempTrash := TempTrash + Copy(lpTextStr, g, 1);
    if lpTextStr[g] = lpSplitChar then
    begin
      CurTemp := Copy(TempTrash, 0, length(TempTrash)-1);
      if bTrim = true then CurTemp := Trim(CurTemp);
      if bQuotes = true then CurTemp := StringReplace(CurTemp, Chr(34), '', [rfReplaceAll]); 
      result.Add(CurTemp);
      TempTrash := '';
    end;
  end;
end;

procedure FilterVar2(lpLineStr: String; var gBindString: TBindString);
var
  g: Integer;
  tmpString: String;
  tmpSplit: TStringList;
begin
  tmpString := '';

  for g := 1 to Pos(' ', lpLineStr) do
  begin
    tmpString := tmpString + lpLineStr[g];
  end;

  gBindString[0] := tmpString;
  lpLineStr := StringReplace(lpLineStr, tmpString, '', [rfIgnoreCase]);
  tmpString := '';


  tmpSplit := TStringList.Create;
  tmpSplit := Split(lpLineStr, ' ', true, false);

  gBindString[1] := FilterVar(tmpSplit.Strings[0], '"');
  gBindString[2] := FilterVar(tmpSplit.Strings[1], '"');

  tmpSplit.Free;
end;

function ExtractEmailFromHtml(lpLineStr: String):String;
var
  tmpTrash: String;
  tmpAddr: String;
  tmpLastTrash: String;
  tmpPosStr: Integer;
  g: LongInt;
begin
  result := '';
  tmpTrash := '';
  tmpAddr := '';
  tmpPosStr := Pos('mailto:', lpLineStr);
  if tmpPosStr <> 0 then
  begin
    tmpTrash := Copy(lpLineStr, tmpPosStr, length(lpLineStr));
    for g := 0 to length(tmpTrash) do
    begin
      tmpAddr := Copy(tmpTrash, 0, g);
      if tmpTrash[g] = '>' then break;
    end;
    if (Pos('@', tmpAddr) <> 0) and (Pos('.', tmpAddr) <> 0) then
    begin
      tmpLastTrash := Copy(tmpAddr, length(tmpAddr) - 1, 2);
      if tmpLastTrash = '">' then
        tmpAddr := Copy(tmpAddr, 0, length(tmpAddr) - 2);
      if Pos('mailto:', tmpAddr) = 1 then
        tmpAddr := Copy(tmpAddr, length('mailto:')+1, length(tmpAddr));
      tmpAddr := Trim(tmpAddr);
      result := tmpAddr;
    end;
  end;
end;

end.